%define _localstatedir /var
%define vroot		%_localstatedir/lib/vservers

Summary:	Linux virtual server utilities
Name:		util-vserver
%define confdir		%_sysconfdir/vservers
%define confdefaultdir	%confdir/.defaults
%define pkglibdir	%_libdir/%name
%define __chattr	/usr/bin/chattr
%define chkconfig	/sbin/chkconfig

Version:	0.30.210
Release:	alt0.M30.1
License:	GPL
Group:		System/Base
URL:		http://savannah.nongnu.org/projects/util-vserver/
Source0:	http://www.13thfloor.at/~ensc/util-vserver/files/alpha/%name-%version.tar.bz2
Patch0:		util-vserver-0.30.210-altlinux.patch
Patch1:		util-vserver-0.30.209-vconfig.patch
Requires:	init(%name)
Requires:	%name-core = %version-%release
Requires:	%name-lib  = %version-%release
Requires:	diffutils mktemp sed
Provides:	vserver = %version-%release


# Automatically added by buildreq on Sat Dec 24 2005
BuildRequires: dietlibc doxygen gcc-c++ iproute2 iptables libbeecrypt-devel libe2fs-devel libstdc++-devel modutils net-tools tetex-core tetex-latex wget
BuildRequires: vlan-utils24 kernel-headers-std26-up

%package lib
Summary:		Dynamic libraries for util-vserver
Group:			System/Libraries

%package core
Summary:		The core-utilities for util-vserver
Group:			System/Servers
Requires:		util-linux
Provides:		%pkglibdir

%package build
Summary:		Tools which can be used to build vservers
Group:			System/Servers
Requires:		rpm wget binutils tar e2fsprogs
Requires:		%name = %version-%release

%ifarch %ix86 x86_64
Requires:		apt
%endif

%package sysv
Summary:		SysV-initscripts for vserver
Group:			System/Base
Provides:		init(%name) = sysv
Requires:		make diffutils
Requires:		%name = %version-%release
Requires:		%_initrddir %pkglibdir %chkconfig

%package legacy
Summary:		Legacy utilities for util-vserver
Group:			System/Servers
Requires:		%name = %version-%release
Requires:		%_initrddir %pkglibdir %chkconfig

%package devel
Summary:		Header-files and libraries needed to develop vserver based applications
Group:			Development/C
Requires:		pkgconfig
Requires:		%name-lib = %version-%release


%description
util-vserver provides the components and a framework to setup virtual
servers.  A virtual server runs inside a linux server. It is nevertheless
highly independent. As such, you can run various services with normal
configuration. The various vservers can't interact with each other and
can't interact with services in the main server.

This requires a special kernel supporting the new new_s_context and
set_ipv4root system call.

%description lib
util-vserver provides the components and a framework to setup virtual
servers.  A virtual server runs inside a linux server. It is nevertheless
highly independent. As such, you can run various services with normal
configuration. The various vservers can't interact with each other and
can't interact with services in the main server.

This package contains the shared libraries needed by all other
'util-vserver' subpackages.

%description core
util-vserver provides the components and a framework to setup virtual
servers.  A virtual server runs inside a linux server. It is nevertheless
highly independent. As such, you can run various services with normal
configuration. The various vservers can't interact with each other and
can't interact with services in the main server.

This package contains utilities which are required to communicate with
the Linux-Vserver enabled kernel.


%description build
util-vserver provides the components and a framework to setup virtual
servers.  A virtual server runs inside a linux server. It is nevertheless
highly independent. As such, you can run various services with normal
configuration. The various vservers can't interact with each other and
can't interact with services in the main server.

This package contains utilities which assist in building Vservers.

%description sysv
util-vserver provides the components and a framework to setup virtual
servers.  A virtual server runs inside a linux server. It is nevertheless
highly independent. As such, you can run various services with normal
configuration. The various vservers can't interact with each other and
can't interact with services in the main server.

This package contains the SysV initscripts which start and stop
VServers and related tools.


%description legacy
util-vserver provides the components and a framework to setup virtual
servers.  A virtual server runs inside a linux server. It is nevertheless
highly independent. As such, you can run various services with normal
configuration. The various vservers can't interact with each other and
can't interact with services in the main server.

This package contains the tools which are needed to work with VServers
having an old-style configuration.


%description devel
util-vserver provides the components and a framework to setup virtual
servers.  A virtual server runs inside a linux server. It is nevertheless
highly independent. As such, you can run various services with normal
configuration. The various vservers can't interact with each other and
can't interact with services in the main server.

This package contains header files and libraries which are needed to
develop VServer related applications.


%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
autoreconf -fisv
%configure --with-initrddir=%_initrddir --enable-release --enable-apis=NOLEGACY \
           %{?_without_dietlibc:--disable-dietlibc} --with-vrootdir=%vroot

%make all
%make doc


%install
%__make DESTDIR="$RPM_BUILD_ROOT" install install-distribution

MANIFEST_CONFIG="%%config" \
MANIFEST_CONFIG_NOREPLACE='%%config(noreplace)' \
contrib/make-manifest %name $RPM_BUILD_ROOT contrib/manifest.dat

%__mkdir_p -m0000 %buildroot%vroot
%__mkdir_p -m0755 %buildroot%vroot/.pkg


%post
test -d /vservers      || mkdir -m0000 %vroot >/dev/null || :
test -d /vservers/.pkg || mkdir -m0755 %vroot/.pkg >/dev/null || :

f="%confdefaultdir/vdirbase"; test -L "$f" -o -e "$f" || ln -s %vroot                  "$f"
f="%confdefaultdir/run.rev";  test -L "$f" -o -e "$f" || ln -s %_localstatedir/run/vservers.rev "$f"
f="%confdefaultdir/cachebase"; test -L "$f" -o -e "$f" || ln -s %_localstatedir/cache/vservers   "$f"

%_sbindir/setattr --barrier %vroot >/dev/null || :

%preun
test "$1" != 0 || rm -rf %_localstatedir/cache/vservers/* 2>/dev/null || :

%post   lib -p %post_ldconfig
%postun lib -p %postun_ldconfig


%post sysv
%chkconfig --add vservers-default
%chkconfig --add vprocunhide



%preun sysv
test "$1" != 0 || %_initrddir/vprocunhide stop &>/dev/null || :

test "$1" != 0 || %chkconfig --del vprocunhide
test "$1" != 0 || %chkconfig --del vservers-default


%postun sysv
test "$1" = 0  || %_initrddir/vprocunhide condrestart >/dev/null || :


%post legacy
%chkconfig --add rebootmgr
%chkconfig --add vservers-legacy

%preun legacy
test "$1" != 0 || %_initrddir/rebootmgr   stop &>/dev/null || :

test "$1" != 0 || %chkconfig --del rebootmgr
test "$1" != 0 || %chkconfig --del vservers-legacy

%postun legacy
test "$1" = 0  || %_initrddir/rebootmgr   condrestart >/dev/null || :


%files -f %name-base.list
%doc AUTHORS COPYING ChangeLog NEWS README THANKS
%doc doc/*.html doc/*.css
/sbin/vshelper
%dir %confdir
%dir %confdefaultdir
%dir %confdefaultdir/apps
%dir %confdefaultdir/files
%dir %pkglibdir/defaults
%attr(000,root,root) %dir %vroot
%ghost %confdefaultdir/cachebase
%ghost %confdefaultdir/vdirbase
%ghost %confdefaultdir/run.rev

%dir %_localstatedir/cache/vservers
%dir %_localstatedir/run/vservers
%dir %_localstatedir/run/vservers.rev
%dir %_localstatedir/run/vshelper

%files lib -f %name-lib.list
%files sysv -f %name-sysv.list


%files core -f %name-core.list
%defattr(-,root,root,-)
%dir %pkglibdir


%files build -f %name-build.list
%doc contrib/yum*.patch
%dir %confdir/.distributions
%dir %confdir/.distributions/*
%dir %confdir/.distributions/*/apt
%dir %confdir/.distributions/.common
%dir %confdir/.distributions/.common/pubkeys
%dir %confdefaultdir/apps/vunify
%dir %confdefaultdir/apps/vunify/hash


%files legacy -f %name-legacy.list
%dir %pkglibdir/legacy


%files devel -f %name-devel.list
%doc lib/apidoc/latex/refman.pdf
%doc lib/apidoc/html


%changelog
* Sun Apr 16 2006 LAKostis <lakostis@altlinux.ru> 0.30.210-alt0.M30.1
- sync with Sisyphus package.
- add 3.0-branch to distribution list.

* Thu Feb 23 2006 LAKostis <lakostis@altlinux.ru> 0.30.209-alt0.M30.1
- rebuild for M30.

* Thu Dec 22 2005 Anton Farygin <rider@altlinux.ru> 0.30.209-alt1
- first build for Sisyphus, based on specfile from %name
